function Shadow::OnSlider() {
	$Pref::ShadowDetailScale = control::Getvalue("Shadow::Slider") / 10;

	if ($pref::ShadowDetailScale > 0)
		control::setvalue("Shadow::SliderText", floor($Pref::ShadowDetailScale * 10 + 0.5));
	else
		control::setvalue("Shadow::SliderText", "off");
}

function Shadow::setmask(%bitvalue, %state) {
	if (%state) {
		$Pref::ShadowDetailMask = ($Pref::ShadowDetailMask | %bitvalue);
		control::setactive("Shadow::TextLabel" @ %bitvalue, true);
	} else {
		$Pref::ShadowDetailMask -= ($Pref::ShadowDetailMask & %bitvalue);
		control::setactive("Shadow::TextLabel" @ %bitvalue, false);
	}

}

function Shadow::OnOpen() { 
	for(%i = 1; %i <= 16; %i *= 2) {
		if (($pref::shadowDetailMask & %i) != 0) {
			control::setvalue("Shadow::CheckBox" @ %i, true);
			control::setactive("Shadow::TextLabel" @ %i, true);
		} else {
			control::setvalue("Shadow::CheckBox" @ %i, false);
			control::setactive("Shadow::TextLabel" @ %i, false);
		}
	}
	
	control::Setvalue("Shadow::Slider", floor($Pref::ShadowDetailScale * 10 + 0.5));
	control::setvalue("Shadow::SliderText", floor($Pref::ShadowDetailScale * 10 + 0.5));
}

newopts::register("Shadow Detail", "config\\vektor\\gui\\shadow.gui", "Shadow::OnOpen();", "Shadow::OnClose();", true);

%header = "Shadow Detail Level";
%text = "This slider lets you customize the \"sharpness\" of the shadows you see Ingame. At lowest setting(off) you won't see any shadows. At higher settings, the edges of the shadows are more well-defined, and less blurred or blended than lower detail levels.";
NewOpts::RegisterHelp("Shadow Detail", %header, %text);

%header = "Shadow Object Masks";
%text = "This section of five buttons let you decide what objects will display shadows, as detailed below:";
NewOpts::RegisterHelp("Shadow Detail", %header, %text);

%header = "Show Player Shadows";
%text = "Check this to make players display shadows.";
NewOpts::RegisterHelp("Shadow Detail", %header, %text);

%header = "Show Vehicle Shadows";
%text = "Check this to make flyer vehicles display shadows.";
NewOpts::RegisterHelp("Shadow Detail", %header, %text);

%header = "Show Item Shadows";
%text = "Check this to make items (packs, weapons, etc) shadows.";
NewOpts::RegisterHelp("Shadow Detail", %header, %text);

%header = "Show Turret Shadows";
%text = "Check this to make turrets display shadows.";
NewOpts::RegisterHelp("Shadow Detail", %header, %text);

%header = "Show Static Object Shadows";
%text = "Check this to make static objects (ie stations, etc) display shadows.";
NewOpts::RegisterHelp("Shadow Detail", %header, %text);
